/* rexx TestLog.CMD version 1.4 01-Jun-2010 */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
PARSE ARG SysId TestId
Host=VALUE('HOSTNAME',,'OS2ENVIRONMENT');
if (Host = '') then Host = "Unknown";
MyDate=DATE('S');
HostDate=Host||'-'||MyDate;
BreakLine='----- Output of: ';
HeaderLine='File created '||DATE('N')||' '||TIME('N')||' by TESTLOG.CMD V1.4 available at http://88watts.net';
BootDrive=left(value('GLOSSARY',,'OS2ENVIRONMENT'),2);
TmpDir = STRIP(value('TMP',,'OS2ENVIRONMENT'),'T','\') || '\';
'@echo off'
do while (QUEUED() <> 0); PULL; end;

select
  when SysId="uniaud" then do
    say "Please type a short description of the test result (1 line):";
    PARSE PULL TestResult;
	MMBase = STRIP(value('MMBASE',,'OS2ENVIRONMENT'),'T',';');
	PkgVer = PkgVersion(MMBase||'\uniaud32.sys');
	if (TestId <> "") then PkgVer = PkgVer || "-" || TestId;
	LogFile = TmpDir || HostDate || '-uniaud-' || PkgVer || '.log';
	ZipFile = TmpDir || HostDate || '-uniaud-' || PkgVer || '.zip';
	rc=SysFileDelete(LogFile);
	rc=LINEOUT(LogFile, HeaderLine);
	rc=LINEOUT(LogFile, "Test result: " || TestResult);
    rc=LINEOUT(LogFile);
	rc = DoCommand('bldlevel '||BootDrive||'\os2krnl');
	rc = DoCommand('bldlevel '||MMBase||'\uniaud32.sys');
    rc = DoCommand('bldlevel '||MMBase||'\uniaud16.sys');
    rc = DoCommand('unimix -card');
	rc = DoCommand('unimix -list');
	rc = DoCommand('unimix -pcms');
	rc = DoCommand('unimix -powerget');
    rc = DoCommand('type alsahlp$');
	rc = DoCommand('pci');
	rc = DoCommand('rmview -irq');
    say LogFile||" has been created.";
	'zip -j -q 'ZipFile' 'LogFile
    say ZipFile||" has been created.";
  end
  when SysId = "genmac" then do
    PARSE VALUE SysIni( , 'Generic MAC Wrapper Driver', 'Path') WITH GMBase'0'x;
    IF ((GMBase = '') | (GMBase = 'ERROR:')) THEN DO
       SAY 'error: cannot find GenMac Installation.';
       exit;
    END
    say "Please type a short description of the test result (1 line):";
    PARSE PULL TestResult;
	PkgVer = PkgVersion(GMBase||'\driver\genm32w.os2');
	if (TestId <> "") then PkgVer = PkgVer || "-" || TestId;
	LogFile = TmpDir || HostDate || '-genmac-' || PkgVer || '.log';
	ZipFile = TmpDir || HostDate || '-genmac-' || PkgVer || '.zip';
	rc=SysFileDelete(LogFile);
	rc=LINEOUT(LogFile, HeaderLine);
	rc=LINEOUT(LogFile, "Test result: " || TestResult);
    rc=LINEOUT(LogFile);
	rc = DoCommand('bldlevel '||BootDrive||'\os2krnl');
	rc = DoCommand('bldlevel '||GMBase||'\driver\genm32w.os2');
    rc = DoCommand('type wrnddb$');
	rc = DoCommand('pci');
    say LogFile||" has been created.";
	'zip -j -q 'ZipFile' 'LogFile
    say ZipFile||" has been created.";
  end
  when SysId="sane" then do
    say "Please type a short description of the test result (1 line):";
    PARSE PULL TestResult;
	SaneBase = 'e:\programs\tame';
	PkgVer = 'V';
	if (TestId <> "") then PkgVer = PkgVer || "-" || TestId;
	LogFile = TmpDir || HostDate || '-sane-' || PkgVer || '.log';
	ZipFile = TmpDir || HostDate || '-sane-' || PkgVer || '.zip';
	rc=SysFileDelete(LogFile);
	rc=LINEOUT(LogFile, HeaderLine);
	rc=LINEOUT(LogFile, "Test result: " || TestResult);
    rc=LINEOUT(LogFile);
	rc = DoCommand('bldlevel '||BootDrive||'\os2krnl');
	'set SANE_DEBUG_microtek2=255';
	'set SANE_DEBUG_SANEI_USB=255';
	'set SANE_DEBUG_DLL=255';
    rc = DoCommand('scanimage -L');
	'set SANE_DEBUG_microtek2=';
	'set SANE_DEBUG_SANEI_USB=';
	'set SANE_DEBUG_DLL=';
    say LogFile||" has been created.";
	'zip -j -q 'ZipFile' 'LogFile
    say ZipFile||" has been created.";
  end
  otherwise do
	say "Usage: testlog uniaud|genmac|sane [testid]";
  end
end
exit;

DoCommand:
  Cmd = ARG(1);
  Line = OVERLAY(Cmd, BreakLine, 18, 80, '-');
  rc=LINEOUT(LogFile, Line); rc=LINEOUT(LogFile);
  Cmd = Cmd || ' 1>>'||LogFile||' 2>&1';
  Cmd;
  RETURN(0);

PkgVersion:
  File = ARG(1);
  '@bldlevel 'File' 2>&1 | rxqueue'
  do while (QUEUED() > 0)
    PARSE PULL Line1':'Line2
    if (Line1 = "File Version") then leave;
    Line2 = "";
  end
  Return(STRIP(Line2,'B'));

